/**
  ******************************************************************************
  * @file    bsp_usart.c
  * @version V1.0
  * @date    2013-xx-xx
  * @brief   õprintfڣضprintf
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ F103-Ե STM32  
  * ̳    :http://www.firebbs.cn
  * Ա    :https://fire-stm32.taobao.com
  *
  ******************************************************************************
  */ 


#include "bsp_usart.h"


 /**
  * @brief  USART GPIO ,
  * @param  
  * @retval 
  */
void USART_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	// 򿪴GPIOʱ
	DEBUG_USART_GPIO_APBxClkCmd(DEBUG_USART_GPIO_CLK, ENABLE);
	
	// 򿪴ʱ
	DEBUG_USART_APBxClkCmd(DEBUG_USART_CLK, ENABLE);

	// USART TxGPIOΪ츴ģʽ
	GPIO_InitStructure.GPIO_Pin = DEBUG_USART_TX_GPIO_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(DEBUG_USART_TX_GPIO_PORT, &GPIO_InitStructure);

  // USART RxGPIOΪģʽ
	GPIO_InitStructure.GPIO_Pin = DEBUG_USART_RX_GPIO_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(DEBUG_USART_RX_GPIO_PORT, &GPIO_InitStructure);
	
	// ôڵĹ
	// ò
	USART_InitStructure.USART_BaudRate = DEBUG_USART_BAUDRATE;
	//  ֳ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	// ֹͣλ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	// Уλ
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	// Ӳ
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	// ùģʽշһ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	// ɴڵĳʼ
	USART_Init(DEBUG_USARTx, &USART_InitStructure);

	// ʹܴ
	USART_Cmd(DEBUG_USARTx, ENABLE);	    
}


///ضc⺯printfڣضʹprintf
int fputc(int ch, FILE *f)
{
		/* һֽݵ */
		USART_SendData(DEBUG_USARTx, (uint8_t) ch);
		
		/* ȴ */
		while (USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_TXE) == RESET);		
	
		return (ch);
}

///ضc⺯scanfڣдʹscanfgetcharȺ
int fgetc(FILE *f)
{
		/* ȴ */
		while (USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_RXNE) == RESET);

		return (int)USART_ReceiveData(DEBUG_USARTx);
}

