/**
  ******************************************************************************
  * @file    bsp_key.c
  * @author  fire
  * @version V1.0
  * @date    2013-xx-xx
  * @brief   Ӧbspɨģʽ
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ F103-Ե STM32  
  * ̳    :http://www.firebbs.cn
  * Ա    :https://fire-stm32.taobao.com
  *
  ******************************************************************************
  */ 
  
#include "bsp_key.h"  

/**
  * @brief  ðõI/O
  * @param  
  * @retval 
  */
void Key_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/*˿ڵʱ*/
	RCC_APB2PeriphClockCmd(KEY1_GPIO_CLK|KEY2_GPIO_CLK,ENABLE);
	
	//ѡ񰴼
	GPIO_InitStructure.GPIO_Pin = KEY1_GPIO_PIN; 
	// ðΪ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING; 
	//ʹýṹʼ
	GPIO_Init(KEY1_GPIO_PORT, &GPIO_InitStructure);
	
	//ѡ񰴼
	GPIO_InitStructure.GPIO_Pin = KEY2_GPIO_PIN; 
	//ðΪ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING; 
	//ʹýṹʼ
	GPIO_Init(KEY2_GPIO_PORT, &GPIO_InitStructure);	
}

 /*
 * Key_Scan
 *   Ƿа
 *   GPIOxx  ABCD E
 *		     GPIO_PinȡĶ˿λ 	
 *   KEY_OFF(û°)KEY_ON°
 */
uint8_t Key_Scan(GPIO_TypeDef* GPIOx,uint16_t GPIO_Pin)
{			
	/*Ƿа */
	if(GPIO_ReadInputDataBit(GPIOx,GPIO_Pin) == KEY_ON )  
	{	 
		/*ȴͷ */
		while(GPIO_ReadInputDataBit(GPIOx,GPIO_Pin) == KEY_ON);   
		return 	KEY_ON;	 
	}
	else
		return KEY_OFF;
}
/*********************************************END OF FILE**********************/
